import _regeneratorRuntime from 'babel-runtime/regenerator';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import InputText from './../InputText';
import Bridge from './../Bridge';

var InputLocation = (_temp = _class = function (_Component) {
  _inherits(InputLocation, _Component);

  function InputLocation(props, context) {
    var _this2 = this;

    _classCallCheck(this, InputLocation);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _this.onClick = function (event, value) {
      // 全局配置
      var _this$context$locale = _this.context.locale,
          locale = _this$context$locale === undefined ? {} : _this$context$locale;
      var _this$props = _this.props,
          _this$props$locationi = _this$props.locationingValue,
          locationingValue = _this$props$locationi === undefined ? locale['location'] || '定位中...' : _this$props$locationi,
          _this$props$failedVal = _this$props.failedValue,
          failedValue = _this$props$failedVal === undefined ? locale['hint_location_failed'] || '定位失败, 请检查定位权限是否开启' : _this$props$failedVal,
          onChange = _this$props.onChange,
          onClick = _this$props.onClick;

      var e = event.nativeEvent;
      if (onClick) onClick(e, value);
      if (_this.$input.value === locationingValue) return;
      // 定位中...
      _this.$input.value = locationingValue;
      Bridge.getLocation({
        type: 'gcj02',
        success: function () {
          var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(data) {
            var result, address;
            return _regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    if (!data.address) {
                      _context.next = 3;
                      break;
                    }

                    // 赋值
                    if (onChange) {
                      onChange(e, data.address, data);
                      _this.$input.value = data.address;
                    }
                    return _context.abrupt('return');

                  case 3:
                    _context.next = 5;
                    return Bridge.getAddress({ // 只支持gcj02
                      latitude: data.latitude,
                      longitude: data.longitude
                    });

                  case 5:
                    result = _context.sent;
                    address = result.address;

                    if (address) {
                      _this.$input.value = address;
                    } else {
                      _this.$input.value = failedValue;
                    }
                    if (onChange) onChange(e, address, result);

                  case 9:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, _this2);
          }));

          return function success(_x) {
            return _ref.apply(this, arguments);
          };
        }(),
        fail: function fail(res) {
          // 赋值
          if (onChange) onChange(e, '', null);
          _this.$input.value = failedValue;
          // 提示定位失败
          Bridge.showToast(res.errMsg, { mask: false });
        }
      });
    };

    return _this;
  }
  // 全局配置


  InputLocation.prototype.componentDidMount = function componentDidMount() {
    this.$el = null;
    this.$input = null;
    if (this.refs.$ComponentInputText && this.refs.$ComponentInputText.$el && this.refs.$ComponentInputText.$input) {
      this.$el = this.refs.$ComponentInputText.$el;
      this.$input = this.refs.$ComponentInputText.$input;
      this.$ComponentInputText = this.refs.$ComponentInputText;
    }
  };

  InputLocation.prototype.render = function render() {
    // 全局配置
    var _context$locale = this.context.locale,
        locale = _context$locale === undefined ? {} : _context$locale;

    var _props = this.props,
        _props$locationingVal = _props.locationingValue,
        locationingValue = _props$locationingVal === undefined ? locale['location'] || '定位中...' : _props$locationingVal,
        _props$failedValue = _props.failedValue,
        failedValue = _props$failedValue === undefined ? locale['hint_location_failed'] || '定位失败, 请检查定位权限是否开启' : _props$failedValue,
        onChange = _props.onChange,
        onClick = _props.onClick,
        others = _objectWithoutProperties(_props, ['locationingValue', 'failedValue', 'onChange', 'onClick']);

    return React.createElement(InputText, _extends({ ref: '$ComponentInputText' }, others, { readOnly: true, onClick: this.onClick }));
  };

  return InputLocation;
}(Component), _class.contextTypes = {
  locale: PropTypes.object,
  portal: PropTypes.object
}, _temp);
export { InputLocation as default };
InputLocation.propTypes = process.env.NODE_ENV !== "production" ? {
  locationingValue: PropTypes.string,
  failedValue: PropTypes.string,
  onClick: PropTypes.func,
  onChange: PropTypes.func
} : {};